/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Simulation;

import SoarBridge.NativeUtils;
import SoarBridge.SoarBridgeException;
import java.util.Locale;
import org.apache.log4j.Logger;


/**
 *
 * @author Danilo
 */
public class SimulationSOAR
{

    static Logger logger = Logger.getLogger(SimulationSOAR.class.getName());


    public static void main(String[] args)
    {
        try
        {
            NativeUtils.setLibraryPath(".");
            System.out.println("OS:"+System.getProperties().getProperty("os.name")+" Architecture:"+System.getProperties().getProperty("os.arch"));
            
	    String osName = System.getProperty("os.name").toLowerCase(Locale.ENGLISH);
            String osArch = System.getProperty("os.arch").toLowerCase(Locale.ENGLISH);
				
            try {
 	      if(osName.contains("win")){
                  if(osArch.contains("64")) {
                    System.out.println("Windows 64 bits");
                    NativeUtils.loadFileFromJar("/win64/Soar.lib");
                    NativeUtils.loadFileFromJar("/win64/Soar.dll");
                    NativeUtils.loadFileFromJar("/win64/Java_sml_ClientInterface.dll");
                  }
                  else {
                    System.out.println("Windows 32 bits");
                    NativeUtils.loadFileFromJar("/win32/Soar.lib");
                    NativeUtils.loadFileFromJar("/win32/Soar.dll");
                    NativeUtils.loadFileFromJar("/win32/Java_sml_ClientInterface.dll");
                  }   
              } else if(osName.contains("mac")){
		    System.out.println("MacOSX");
                    NativeUtils.loadFileFromJar("/macos/libSoar.dylib");
                    NativeUtils.loadFileFromJar("/macos/libJava_sml_ClientInterface.jnilib");
              } else if(osName.contains("nix") || osName.contains("nux")){
                  if(osArch.contains("64")) {
                      System.out.println("Linux 64 bits");
                      NativeUtils.loadFileFromJar("/linux64/libSoar.so");
                      NativeUtils.loadFileFromJar("/linux64/libJava_sml_ClientInterface.so");
                  }
                 else {
                      System.out.println("Linux 32 bits");
                      NativeUtils.loadFileFromJar("/linux32/libSoar.so");
                      NativeUtils.loadFileFromJar("/linux32/libJava_sml_ClientInterface.so");
                }
              } else{
		//Unable to identify
		throw new IllegalStateException("Unable to determine what the operating system is, cannot automatically load native libraries");
	      }
            } catch (Exception e) {
		System.out.println("Unable to load native libraries. They must be set manually with '-Djava.library.path'"+e);
	        //We failed. We shouldn't kill the application however, linking *may* have succeeded because of user manually setting location
            }
            NativeUtils.loadFileFromJar("/soar-rules.soar");
            String soarRulesPath = "soar-rules.soar";
            String soarDebuggerPath = "";
            Integer soarDebuggerPort = 12121;

            // Config Log
            //ClientLogger.configLogger();

            //Start enviroment data
            SimulationTask simulationTask = new SimulationTask();
            simulationTask.initializeEnviroment(Boolean.FALSE);
            simulationTask.initializeCreatureAndSOAR(soarRulesPath,true,soarDebuggerPath,soarDebuggerPort);

            // Run Simulation until some criteria was reached
            Thread.sleep(3000);

            while(simulationTask.run)
            {
                simulationTask.runSimulation();
                Thread.sleep(100);
            }
        }
        catch (SoarBridgeException ex)
        {
            logger.error("Error in soar bridge",ex);
        }
        catch (Exception ex)
        {
            System.out.println(ex.toString());
            ex.printStackTrace();
            logger.error("Unknown error",ex);
        }
    }


}
